using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class triggerscript : MonoBehaviour
{
    int objno = 2;
    rtcmixmain RTcmix;
    private bool did_start = false;

    bool is_going = false;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
    }

    private void OnTriggerEnter(Collider other)
    {
        if (is_going == false) {
            string score = "setup(irand(1500, 2500), 10, 1) " +
                "amp = 20000 " +
                "ampenv = maketable(\"line\", 1000, 0,1, 2, 0.3, 10,0) " +
                "dur = 0.01 " +
                "IINOISE(0, dur, amp*ampenv, random()) " +
                "MAXBANG(irand(dur/2, dur)) ";
            RTcmix.SendScore(score, objno);

            is_going = true;
        }
    }

    private void OnTriggerExit(Collider other)
    {
        is_going = false;
    }


    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            if (is_going == true)
            {
                string score = "setup(irand(1500, 2500), 10, 1) " +
                    "amp = 20000 " +
                    "ampenv = maketable(\"line\", 1000, 0,1, 2, 0.3, 10,0) " +
                    "dur = 0.01 " +
                    "IINOISE(0, dur, amp*ampenv, random()) " +
                    "MAXBANG(irand(dur/2, dur)) ";
                RTcmix.SendScore(score, objno);
            }
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
